import asyncio
import json
import requests
from bilibili_api import video


# 将bilibili某位up主的近期0-100个视频的播放量转为折线图
# 输入:
#   uid: up主的uid
#   ps:  视频数量 || 范围: 0-100
# 返回:
#   x: x轴的数据 (播放量)
#   y: y轴的数据 (第n个视频 || 从旧到新)
def bili_look(uid, ps):
    y = []
    x = []
    if ps > 100:
        raise ValueError('视频数量 必须小于等于100，否则返回的JSON状态码是-400')
    home_url = "https://api.bilibili.com/x/space/arc/search?mid=%d&ps=%d&tid=0&pn=1&keyword=&order=pubdate&jsonp=jsonp" \
               % (uid, ps)

    headers = {
        'User-Agent': 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:81.0) Gecko/20100101 Firefox/81.0'
    }
    html = requests.get(url=home_url, headers=headers)
    html_content = html.text
    json_html = json.loads(html_content)
    print('[INFO] 正在获取JSON：')
    print(json_html)
    print('[INFO] 正在获取BV号：')
    for i in json_html['data']['list']['vlist']:
        print(i['bvid'])
    for i in range(len(json_html['data']['list']['vlist']) + 1, 1, -1):
        x.append(i)

    async def main(bvid):
        # 实例化 Video 类
        v = video.Video(bvid=bvid)
        # 获取信息
        info = await v.get_info()
        # 打印信息
        y.append(info['stat']['view'])
        print(bvid, '=', info['stat']['view'])

    for i in json_html['data']['list']['vlist']:
        print('[INFO] 正在获取播放量')
        asyncio.get_event_loop().run_until_complete(main(i['bvid']))
    return x, y