import time
from psutil import disk_partitions


# 生成日志
# 必须包含“log[Debug].txt”文件
# 必须包含“log[xxx].txt”
# level = “log[xxx].txt”中的“xxx”
# msg = 日志信息
# encoding = 文件编码（默认GBK）
# output = 0/1 || 0 = 不在控制台输出 || 1 = 在控制台输出 || 默认1
def log(level, msg, encoding='GBK', output=1):
    if output:
        print('[%s] %s' % (level, msg))
    with open('log[%s].txt' % level, 'a', encoding=encoding) as f:
        f.write('[%s] %s\n' % (level, msg))
    with open('../../pythonProject6/log[Debug].txt', 'a', encoding=encoding) as f:
        f.write('[%s] %s\n' % (level, msg))


# 查找可移动设备（若没有会等待一秒，继续查找）
def find_driver():
    while True:
        #  设置休眠时间
        time.sleep(1)
        #  检测所有的驱动器，进行遍历寻找
        for item in disk_partitions():
            if 'removable' in item.opts:
                driver, opts = item.device, item.opts
                return driver


# 列出文件夹下所有的目录与文件
def get_all_path(open_file_path):
    root_dir = open_file_path
    path_list = []
    list = os.listdir(root_dir)  # 列出文件夹下所有的目录与文件
    for i in range(0, len(list)):
        com_path = os.path.join(root_dir, list[i])
        if os.path.isfile(com_path):
            path_list.append(com_path)
        if os.path.isdir(com_path):
            path_list.extend(get_all_path(com_path))
    return path_list